-- orginal found on glsl sandbox
-- modified by Ref 5/19/2013

local sphere={}

sphere.effect = love.graphics.newPixelEffect[[

extern number time	= 0.0;
extern vec2 screen;
extern vec2 mouse;

vec4 effect( vec4 color, Image texture, vec2 texture_coords, vec2 pixel_coords )
{

#define RADIUS 0.2		// h = bounce height
	number	h			= 0.6 * ( 1.0*screen.x/screen.y - pow(2.0 * fract(time*0.5) - 1.0, 2.0));
	number	xpos		= fract( time * 0.2 ); // time to transit
	if( xpos > 0.5 ) xpos = 1.0 - xpos;
	xpos				= RADIUS + 3.0 * xpos * (1.0 - RADIUS * 3.0);
	vec2	center		= screen * vec2( xpos, RADIUS + h );
	vec2	position	= ( (pixel_coords - center) / screen.x );

#define SCALE ( 5.0929581 * 0.5 )	// size of checker pattern
	position			*= ( 1.0 / RADIUS );
	number	r			= length( position );
	number	diffuse		= 0.0;
	if( r <= 1.0 )
		{
		number	z		= sqrt( 1.0 - r*r );
		vec3	norm	= vec3( position, z );
		vec3	fix		= norm;
		number	tilt	= -0.2;
		vec2	mat		= vec2( cos(tilt), sin(tilt) );
			fix.x		= dot( norm.xy, mat );
			fix.y		= dot( norm.xy, vec2( -mat.y, mat.x ) );
		number	lat		= asin( fix.y );
		number	lon		= atan( fix.x, fix.z ) + xpos * 8.0; // ball rotation
		number	y		= SCALE * log( 1.0 / cos( lat ) + tan( lat ) );
		number	x		= lon * SCALE;
		number	t		= fract( y );
		if ( fract(x) < 0.5 ) t = 1.0 - t;
		if ( t < 0.5 ) color.g = color.b = 1.0;
		vec3	lightpos= normalize( vec3( mouse[0]/screen.x, 0.5-mouse[1]/screen.y, 1 ) );
			diffuse		= dot( norm, lightpos );
			diffuse		= max( diffuse, 0.0 ) + 0.14; //light spot size
		vec3	halfdir	= normalize(lightpos + vec3( 0.0, 0.0, 0.0 ));
		}
	return vec4( color * diffuse );
}
]]

return sphere
